#ifndef _STUDENTINCOURSE_H
#define _STUDENTINCOURSE_H

#include <string>
#include <fstream>

using namespace std;

class StudentInCourse
{
public:
   struct SICKey
   {
      unsigned int      sIdNum;
      Course::CourseKey CCode;
      explicit SICKey( int aIdNum=0, string aCCode="" )
      {  sIdNum = aIdNum;  CCode = Course::CourseKey(aCCode);  }
   }; // SICKey
   explicit StudentInCourse( int aIdNum=0, string aCCode="" );
   ~StudentInCourse() { };
// getters
   unsigned int getSIdNum() const {  return sicSIdNum;  }
   const char* getCCode() const {  return sicCCode.s;  }
   float getMark() const {  return sicMark;  }
   SICKey getKey() const
   {  return SICKey( sicSIdNum, sicCCode.s );  }
// setters
   void setSIdNum( int aIdNum );
   void setCCode( string aCode);
   void setMark( float aMark );
// other
   void save( ostream& bout ) const;
   void load( istream& bin );
   void display( ostream& tout ) const;
private:
   enum { sicCCodeSz = 8,
          sicSaveSz = sizeof(int) + sicCCodeSz + sizeof(float) };
   unsigned int      sicSIdNum;  //  
   Course::CourseKey sicCCode;   //  
   float             sicMark;    //   
}; // StudentInCourse

typedef StudentInCourse* PStudentInCourse;

bool operator!=( const StudentInCourse::SICKey& lhs,
                 const StudentInCourse::SICKey& rhs )
{  return ( (lhs.sIdNum != rhs.sIdNum) ||
            (lhs.CCode != rhs.CCode) );  }

bool operator==( const StudentInCourse::SICKey& lhs,
                 const StudentInCourse::SICKey& rhs )
{
   return ( !(lhs != rhs) );
}

bool operator!=( const StudentInCourse& lhs,
                 const StudentInCourse& rhs )
{  return ( lhs.getKey() != rhs.getKey() );  }

bool operator==( const StudentInCourse& lhs,
                 const StudentInCourse& rhs )
{  return ( !(lhs != rhs) );  }

struct StudentInCourseXptn
{
   enum { negIdNum, keyLen, rangeError,
          unknownCCode, fileNotOpen, cannotWrite };
   StudentInCourse::SICKey objKey;
   char                    methodName[100];
   int                     errorCode;
   char                    errStrVal[100];
   float                   errFltVal;
   StudentInCourseXptn( const StudentInCourse::SICKey obk,
                        const char* mn, int ec, const char* sv="" )
      :  objKey( obk ),  errorCode( ec )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';
      strncpy( errStrVal, sv, 99 );  errStrVal[99] = '\0';  }
   StudentInCourseXptn( const StudentInCourse::SICKey& obk,
                        const char* mn, int ec, float fv )
      :  objKey( obk ),  errorCode( ec ),  errFltVal( fv )
   {  strncpy( methodName, mn, 99 );  methodName[99] = '\0';  }
}; // StudentInCourseXptn

#endif // _STUDENTINCOURSE_H
